#  ICE Revision: $Id: ReadDictionary.py 7855 2007-09-03 09:47:26Z bgschaid $ 
"""
Application class that implements pyFoamReadDictionary
"""

import sys

from PyFoamApplication import PyFoamApplication

from PyFoam.RunDictionary.ParsedParameterFile import ParsedParameterFile

class ReadDictionary(PyFoamApplication):
    def __init__(self,args=None):
        description="""
Reads a value from a Foam-Dictionary and prints it to the screen.
The description of the value is word. If the value is
non-atomic (a list or a dictionary) it is output in Python-notation.
Parts of the expression can be accessed with an option
        """
        
        PyFoamApplication.__init__(self,args=args,description=description,usage="%prog [options] <dictfile> <key>",nr=2,interspersed=True)
        
    def addOptions(self):
        self.parser.add_option("--subexpression",action="store",default=None,dest="subexpression",help="A subexpression (in python notation to access parts of the value)")
        self.parser.add_option("--debug",action="store_true",default=None,dest="debug",help="Debugs the parser")
        
    
    def run(self):
        fName=self.parser.getArgs()[0]
        key=self.parser.getArgs()[1]

        try:
            dictFile=ParsedParameterFile(fName,backup=False,debug=self.opts.debug)
            val=dictFile[key]
        except KeyError:
            self.error("Key: ",key,"not existing in File",fName)
        except IOError,e:
            self.error("Problem with file",fName,":",e)

        if self.opts.subexpression==None:
            erg=val
        else:
            try:
                erg=eval(str(val)+self.opts.subexpression)
            except Exception,e:
                self.error("Problem with subexpression:",sys.exc_info()[0],":",e)
                
        print erg
            
